'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _extends = require('@babel/runtime/helpers/extends');
var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _classCallCheck = require('@babel/runtime/helpers/classCallCheck');
var _createClass = require('@babel/runtime/helpers/createClass');
var _inherits = require('@babel/runtime/helpers/inherits');
var _possibleConstructorReturn = require('@babel/runtime/helpers/possibleConstructorReturn');
var _getPrototypeOf = require('@babel/runtime/helpers/getPrototypeOf');
var React = require('react');
var reactIntl = require('react-intl');
var reactRedux = require('react-redux');
var icons = require('@material-ui/icons');
var feCore = require('@openimis/fe-core');
var _assertThisInitialized = require('@babel/runtime/helpers/assertThisInitialized');
var core = require('@material-ui/core');
var AddIcon = require('@material-ui/icons/Add');
var styles$9 = require('@material-ui/core/styles');
var _asyncToGenerator = require('@babel/runtime/helpers/asyncToGenerator');
var _regeneratorRuntime = require('@babel/runtime/regenerator');
var redux = require('redux');
var _debounce = require('lodash/debounce');
require('lodash');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var ReplayIcon = require('@material-ui/icons/Replay');
var DeleteIcon = require('@material-ui/icons/Delete');
var lab = require('@material-ui/lab');
var Autocomplete = require('@material-ui/lab/Autocomplete');
var TextField = require('@material-ui/core/TextField');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _extends__default = /*#__PURE__*/_interopDefaultLegacy(_extends);
var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _classCallCheck__default = /*#__PURE__*/_interopDefaultLegacy(_classCallCheck);
var _createClass__default = /*#__PURE__*/_interopDefaultLegacy(_createClass);
var _inherits__default = /*#__PURE__*/_interopDefaultLegacy(_inherits);
var _possibleConstructorReturn__default = /*#__PURE__*/_interopDefaultLegacy(_possibleConstructorReturn);
var _getPrototypeOf__default = /*#__PURE__*/_interopDefaultLegacy(_getPrototypeOf);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var _assertThisInitialized__default = /*#__PURE__*/_interopDefaultLegacy(_assertThisInitialized);
var AddIcon__default = /*#__PURE__*/_interopDefaultLegacy(AddIcon);
var _asyncToGenerator__default = /*#__PURE__*/_interopDefaultLegacy(_asyncToGenerator);
var _regeneratorRuntime__default = /*#__PURE__*/_interopDefaultLegacy(_regeneratorRuntime);
var _debounce__default = /*#__PURE__*/_interopDefaultLegacy(_debounce);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var ReplayIcon__default = /*#__PURE__*/_interopDefaultLegacy(ReplayIcon);
var DeleteIcon__default = /*#__PURE__*/_interopDefaultLegacy(DeleteIcon);
var Autocomplete__default = /*#__PURE__*/_interopDefaultLegacy(Autocomplete);
var TextField__default = /*#__PURE__*/_interopDefaultLegacy(TextField);

var RIGHT_PRODUCTS = 121001;
var RIGHT_HEALTHFACILITIES = 121101;
var RIGHT_PRICELISTMS = 121201;
var RIGHT_PRICELISTMI = 121301;
var RIGHT_MEDICALSERVICES = 121401;
var RIGHT_MEDICALITEMS = 122101;
var RIGHT_ENROLMENTOFFICER = 121501;
var RIGHT_CLAIMADMINISTRATOR = 121601;
var RIGHT_LOCATIONS = 121901;
var RIGHT_USERS = 121701;
var RIGHT_USER_ADD = 121702;
var RIGHT_USER_EDIT = 121703;
var RIGHT_USER_DELETE = 121704;
var INTERACTIVE_USER_TYPE = "INTERACTIVE";
var ENROLMENT_OFFICER_USER_TYPE = "OFFICER";
var CLAIM_ADMIN_USER_TYPE = "CLAIM_ADMIN";
var USER_TYPES = function USER_TYPES(rights) {
  var baseTypes = [INTERACTIVE_USER_TYPE];
  if (rights.includes(RIGHT_ENROLMENTOFFICER)) {
    baseTypes.push(ENROLMENT_OFFICER_USER_TYPE);
    if (rights.includes(RIGHT_CLAIMADMINISTRATOR)) {
      baseTypes.push(CLAIM_ADMIN_USER_TYPE);
    }
  }
  return baseTypes;
};

function _createSuper$4(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$4(); return function _createSuperInternal() { var Super = _getPrototypeOf__default["default"](Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf__default["default"](this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn__default["default"](this, result); }; }
function _isNativeReflectConstruct$4() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var ADMIN_MAIN_MENU_CONTRIBUTION_KEY = "admin.MainMenu";
var AdminMainMenu = /*#__PURE__*/function (_Component) {
  _inherits__default["default"](AdminMainMenu, _Component);
  var _super = _createSuper$4(AdminMainMenu);
  function AdminMainMenu() {
    _classCallCheck__default["default"](this, AdminMainMenu);
    return _super.apply(this, arguments);
  }
  _createClass__default["default"](AdminMainMenu, [{
    key: "render",
    value: function render() {
      var rights = this.props.rights;
      var entries = [];
      if (rights.includes(RIGHT_PRODUCTS)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.products"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.Tune, null),
          route: "/admin/products"
        });
      }
      if (rights.includes(RIGHT_HEALTHFACILITIES)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.healthFacilities"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.LocalHospital, null),
          route: "/location/healthFacilities",
          withDivider: true
        });
      }
      if (rights.includes(RIGHT_PRICELISTMS)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.medicalServicesPrices"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.HealingOutlined, null),
          route: "/medical/pricelists/services"
        });
      }
      if (rights.includes(RIGHT_PRICELISTMI)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.medicalItemsPrices"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.LocalPharmacyOutlined, null),
          route: "/medical/pricelists/items",
          withDivider: true
        });
      }
      if (rights.includes(RIGHT_MEDICALSERVICES)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.medicalServices"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.Healing, null),
          route: "/medical/medicalServices"
        });
      }
      if (rights.includes(RIGHT_MEDICALITEMS)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.medicalItems"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.LocalPharmacy, null),
          route: "/medical/medicalItems",
          withDivider: true
        });
      }
      if (rights.includes(RIGHT_USERS)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.users"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.Person, null),
          route: "/admin/users"
        });
      }
      if (rights.includes(RIGHT_LOCATIONS)) {
        entries.push({
          text: feCore.formatMessage(this.props.intl, "admin", "menu.locations"),
          icon: /*#__PURE__*/React__default["default"].createElement(icons.PinDrop, null),
          route: "/location/locations"
        });
      }
      entries.push.apply(entries, _toConsumableArray__default["default"](this.props.modulesManager.getContribs(ADMIN_MAIN_MENU_CONTRIBUTION_KEY).filter(function (c) {
        return !c.filter || c.filter(rights);
      })));
      if (!entries.length) return null;
      return /*#__PURE__*/React__default["default"].createElement(feCore.MainMenuContribution, _extends__default["default"]({}, this.props, {
        header: feCore.formatMessage(this.props.intl, "admin", "mainMenu"),
        icon: /*#__PURE__*/React__default["default"].createElement(icons.LocationCity, null),
        entries: entries
      }));
    }
  }]);
  return AdminMainMenu;
}(React.Component);
var mapStateToProps$3 = function mapStateToProps(state) {
  return {
    rights: !!state.core && !!state.core.user && !!state.core.user.i_user ? state.core.user.i_user.rights : []
  };
};
var AdminMainMenu$1 = feCore.withModulesManager(reactIntl.injectIntl(reactRedux.connect(mapStateToProps$3)(AdminMainMenu)));

function ownKeys$6(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$6(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys$6(Object(source), !0).forEach(function (key) { _defineProperty__default["default"](target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$6(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper$3(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$3(); return function _createSuperInternal() { var Super = _getPrototypeOf__default["default"](Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf__default["default"](this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn__default["default"](this, result); }; }
function _isNativeReflectConstruct$3() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var styles$8 = function styles(theme) {
  return {
    dialogTitle: theme.dialog.title,
    dialogContent: theme.dialog.content,
    form: {
      padding: "0 0 10px 0",
      width: "100%"
    },
    item: {
      padding: theme.spacing(1)
    },
    paperDivider: theme.paper.divider
  };
};
var getParentLocation = function getParentLocation(locations) {
  var locationsArray = Object.values(locations).map(function (l) {
    return l.value;
  });
  var region = locationsArray.find(function (l) {
    return !l.parent;
  });
  var district = region && locationsArray.find(function (l) {
    return l.parent && l.parent.id === region.id;
  });
  var municipality = district && locationsArray.find(function (l) {
    return l.parent && l.parent.id === district.id;
  });
  var village = municipality && locationsArray.find(function (l) {
    return l.parent && l.parent.id === municipality.id;
  });
  if (!region) {
    return null;
  }
  var newLocation = {
    key: "regionId",
    id: feCore.decodeId(region.id)
  };
  if (district) {
    newLocation = {
      key: "districtId",
      id: feCore.decodeId(district.id)
    };
  }
  if (municipality) {
    newLocation = {
      key: "municipalityId",
      id: feCore.decodeId(municipality.id)
    };
  }
  if (village) {
    newLocation = {
      key: "villageId",
      id: feCore.decodeId(village.id)
    };
  }
  return newLocation;
};
var UserFilter = /*#__PURE__*/function (_Component) {
  _inherits__default["default"](UserFilter, _Component);
  var _super = _createSuper$3(UserFilter);
  function UserFilter() {
    var _this;
    _classCallCheck__default["default"](this, UserFilter);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "state", {
      currentUserType: undefined,
      currentUserRoles: undefined,
      locationFilters: {}
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "debouncedOnChangeFilter", _debounce__default["default"](_this.props.onChangeFilters, _this.props.modulesManager.getConf("fe-admin", "debounceTime", 800)));
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "filterValue", function (k) {
      var filters = _this.props.filters;
      return !!filters && !!filters[k] ? filters[k].value : null;
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "onChangeShowHistory", function () {
      var filters = [{
        id: "showHistory",
        value: !_this.state.showHistory,
        filter: "showHistory: ".concat(!_this.state.showHistory)
      }];
      _this.props.onChangeFilters(filters);
      _this.setState(function (state) {
        return {
          showHistory: !state.showHistory
        };
      });
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "onChangeUserTypes", function (currentUserType) {
      var onChangeFilters = _this.props.onChangeFilters;
      _this.setState({
        currentUserType: currentUserType
      });
      onChangeFilters([{
        id: "userTypes",
        value: currentUserType,
        filter: currentUserType ? "userTypes: [".concat(currentUserType, "]") : null
      }]);
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "onChangeUserRoles", function (currentUserRoles) {
      var onChangeFilters = _this.props.onChangeFilters;
      _this.setState({
        currentUserRoles: currentUserRoles
      });
      onChangeFilters([{
        id: "roles",
        value: currentUserRoles,
        filter: currentUserRoles ? "roles: [".concat(currentUserRoles.map(function (ur) {
          return feCore.decodeId(ur.id);
        }).join(","), "]") : null
      }]);
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "onChangeLocation", function (newLocationFilters) {
      var onChangeFilters = _this.props.onChangeFilters;
      var locationFilters = _objectSpread$6({}, _this.state.locationFilters);
      newLocationFilters.forEach(function (filter) {
        if (filter.value === null) {
          delete locationFilters[filter.id];
        } else {
          locationFilters[filter.id] = {
            value: filter.value,
            filter: filter.filter
          };
        }
      });
      _this.setState({
        locationFilters: locationFilters
      });
      var parentLocation = getParentLocation(locationFilters);
      var filters = [{
        id: "parentLocation",
        filter: parentLocation && "".concat(parentLocation.key, ": ").concat(parentLocation.id)
      }];
      onChangeFilters(filters);
    });
    return _this;
  }
  _createClass__default["default"](UserFilter, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        classes = _this$props.classes,
        onChangeFilters = _this$props.onChangeFilters;
      var _this$state = this.state,
        locationFilters = _this$state.locationFilters,
        currentUserType = _this$state.currentUserType,
        currentUserRoles = _this$state.currentUserRoles;
      return /*#__PURE__*/React__default["default"].createElement("section", {
        className: classes.form
      }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
        container: true
      }, /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.userTypes",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
          pubRef: "admin.UserTypesPicker",
          value: currentUserType,
          onChange: function onChange(v) {
            return _this2.onChangeUserTypes(v);
          }
        }))
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.userRoles",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
          pubRef: "admin.UserRolesPicker",
          value: currentUserRoles,
          onChange: function onChange(v) {
            return _this2.onChangeUserRoles(v);
          }
        }))
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.healthFacility",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
          pubRef: "location.HealthFacilityPicker",
          withNull: true,
          value: this.filterValue("healthFacilityId") || "",
          onChange: function onChange(v) {
            onChangeFilters([{
              id: "healthFacility",
              value: v,
              filter: v ? "healthFacilityId: ".concat(feCore.decodeId(v.id)) : null
            }]);
          }
        }))
      })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
        container: true
      }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
        item: true,
        xs: 12
      }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
        pubRef: "location.DetailedLocationFilter",
        withNull: true,
        filters: locationFilters,
        onChangeFilters: this.onChangeLocation,
        anchor: "parentLocation"
      }))), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
        container: true
      }, /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.username",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
          module: "user",
          label: "admin.user.username",
          name: "username",
          value: this.filterValue("username"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "username",
              value: v,
              filter: "username_Icontains: \"".concat(v, "\"")
            }]);
          }
        }))
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.LastName",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
          module: "user",
          label: "admin.user.lastName",
          name: "lastName",
          value: this.filterValue("lastName"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "lastName",
              value: v,
              filter: "lastName: \"".concat(v, "\"")
            }]);
          }
        }))
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.OtherNames",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
          module: "user",
          label: "admin.user.otherNames",
          name: "otherNames",
          value: this.filterValue("otherNames"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "otherNames",
              value: v,
              filter: "otherNames: \"".concat(v, "\"")
            }]);
          }
        }))
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.Email",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
          module: "user",
          label: "admin.user.email",
          name: "email",
          value: this.filterValue("email"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "email",
              value: v,
              filter: "email: \"".concat(v, "\"")
            }]);
          }
        }))
      })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
        container: true
      }, /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "userFilter.Phone",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 3,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
          module: "user",
          label: "admin.user.phone",
          name: "phone",
          value: this.filterValue("phone"),
          onChange: function onChange(v) {
            return _this2.debouncedOnChangeFilter([{
              id: "phone",
              value: v,
              filter: "phone: \"".concat(v, "\"")
            }]);
          }
        }))
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ControlledField, {
        module: "admin",
        id: "UserFilter.dob",
        field: /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 6
        }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          container: true
        }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 6,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
          pubRef: "core.DatePicker",
          value: this.filterValue("dobFrom"),
          module: "user",
          label: "admin.user.dobFrom",
          onChange: function onChange(d) {
            return onChangeFilters([{
              id: "dobFrom",
              value: d,
              filter: "birthDateFrom: \"".concat(d, "\"")
            }]);
          }
        })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
          item: true,
          xs: 6,
          className: classes.item
        }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
          pubRef: "core.DatePicker",
          value: this.filterValue("dobTo"),
          module: "user",
          label: "admin.user.dobTo",
          onChange: function onChange(d) {
            return onChangeFilters([{
              id: "dobTo",
              value: d,
              filter: "birthDateTo: \"".concat(d, "\"")
            }]);
          }
        }))))
      })));
    }
  }]);
  return UserFilter;
}(React.Component);
var UserFilter$1 = feCore.withModulesManager(reactIntl.injectIntl(styles$9.withTheme(styles$9.withStyles(styles$8)(UserFilter))));

var getUserTypes = function getUserTypes(user) {
  var _user$officer, _user$claimAdmin;
  // We force from now on all users to be interactive
  var userTypes = [INTERACTIVE_USER_TYPE];
  if ((_user$officer = user.officer) !== null && _user$officer !== void 0 && _user$officer.id) {
    userTypes.push(ENROLMENT_OFFICER_USER_TYPE);
  }
  if ((_user$claimAdmin = user.claimAdmin) !== null && _user$claimAdmin !== void 0 && _user$claimAdmin.id) {
    userTypes.push(CLAIM_ADMIN_USER_TYPE);
  }
  return userTypes;
};
var mapQueriesUserToStore = function mapQueriesUserToStore(u) {
  // TODO: make this more generic
  u.hasLogin = false;
  u.userTypes = getUserTypes(u);
  if (u.iUser) {
    u.hasLogin = true;
    u.lastName = u.iUser.lastName;
    u.otherNames = u.iUser.otherNames;
    u.email = u.iUser.email;
    u.phoneNumber = u.iUser.phone;
    u.healthFacility = u.iUser.healthFacility;
    u.language = u.iUser.languageId;
    u.roles = u.iUser.roles;
    u.districts = u.iUser.districts.map(function (d) {
      return d.location;
    });
  }
  if (u.claimAdmin) {
    var _u$email;
    u.hasLogin = u.hasLogin || u.claimAdmin.hasLogin;
    u.lastName = u.claimAdmin.lastName;
    u.otherNames = u.claimAdmin.otherNames;
    u.email = (_u$email = u.email) !== null && _u$email !== void 0 ? _u$email : u.claimAdmin.emailId;
    u.phoneNumber = u.claimAdmin.phone;
    u.birthDate = u.claimAdmin.dob;
    u.healthFacility = u.claimAdmin.healthFacility;
  }
  if (u.officer) {
    var _u$email2;
    u.hasLogin = u.hasLogin || u.officer.hasLogin;
    u.lastName = u.officer.lastName;
    u.otherNames = u.officer.otherNames;
    u.email = (_u$email2 = u.email) !== null && _u$email2 !== void 0 ? _u$email2 : u.officer.email;
    u.phoneNumber = u.officer.phone;
    u.birthDate = u.officer.dob;
    u.address = u.officer.address;
    u.substitutionOfficer = u.officer.substitutionOfficer;
    // substitutionOfficer is user.officer so it cannot be retrieved using the UserPicker
    u.worksTo = u.officer.worksTo;
    u.location = u.officer.location;
    u.officerVillages = u.officer.officerVillages.map(function (x) {
      return x.location;
    });
  }
  return u;
};
var mapUserValuesToInput = function mapUserValuesToInput(values) {
  var _values$substitutionO, _values$officerVillag;
  var input = {
    uuid: values.id ? feCore.decodeId(values.id) : null,
    username: values.username,
    userTypes: values.userTypes,
    lastName: values.lastName,
    otherNames: values.otherNames,
    phone: values.phoneNumber,
    email: values.email,
    password: values.password,
    healthFacilityId: values.healthFacility ? feCore.decodeId(values.healthFacility.id) : null,
    districts: values.districts.map(function (d) {
      return feCore.decodeId(d.id);
    }),
    locationId: values.location ? feCore.decodeId(values.location.id) : null,
    language: values.language,
    roles: values.roles.map(function (r) {
      return feCore.decodeId(r.id);
    }),
    birthDate: values.birthDate,
    address: values.address,
    substitutionOfficerId: (_values$substitutionO = values.substitutionOfficer) !== null && _values$substitutionO !== void 0 && _values$substitutionO.id ? feCore.decodeId(values.substitutionOfficer.id) : null,
    worksTo: values.worksTo,
    villageIds: (_values$officerVillag = values.officerVillages) === null || _values$officerVillag === void 0 ? void 0 : _values$officerVillag.map(function (location) {
      return feCore.decodeId(location.id);
    })
  };
  return input;
};
var toggleUserType = function toggleUserType(user, type) {
  if (!user.userTypes) {
    // eslint-disable-next-line no-param-reassign
    user.userTypes = [];
  }
  if (user.userTypes.includes(type)) {
    // eslint-disable-next-line no-param-reassign
    user.userTypes = user.userTypes.filter(function (x) {
      return x !== type;
    });
  } else {
    user.userTypes.push(type);
  }
  return user;
};

var USER_SUMMARY_PROJECTION = ["id", "username", "officer{id,dob,phone,lastName,otherNames,email}", "iUser{id,phone,lastName,otherNames,email,roles{id,name}}", "claimAdmin{id,phone,lastName,otherNames,emailId,dob}", "clientMutationId"];
var USER_PICKER_PROJECTION = ["id", "username", "iUser{id otherNames lastName}"];
function fetchUsers(mm) {
  var filters = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var restrictHealthFacility = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  return function (dispatch, getState) {
    if (restrictHealthFacility) {
      var state = getState();
      var hf = state.loc.userHealthFacilityFullPath;
      if (hf) {
        filters.push("healthFacility_Uuid: \"".concat(hf.uuid, "\""));
      }
    }
    var payload = feCore.formatPageQuery("users", filters, mm.getRef("admin.UserPicker.projection"));
    return dispatch(feCore.graphql(payload, "ADMIN_USERS", filters));
  };
}
function fetchUsersSummaries(mm, filters) {
  var payload = feCore.formatPageQueryWithCount("users", filters, USER_SUMMARY_PROJECTION);
  return feCore.graphql(payload, "ADMIN_USERS_SUMMARIES");
}
function fetchEnrolmentOfficers(mm, variables) {
  return feCore.graphqlWithVariables("\n      query ($searchString: String, $first: Int) {\n        enrolmentOfficers(str: $searchString, first: $first) {\n          edges {\n            node {\n              id\n              code\n              lastName\n              otherNames\n              \n            }\n          }\n          pageInfo {\n            hasNextPage\n          }\n        }\n      }\n    ", variables, "ADMIN_ENROLMENT_OFFICERS");
}
function createUser(mm, user, clientMutationLabel) {
  var mutation = feCore.prepareMutation("\n    mutation ($input: CreateUserMutationInput!) {\n      createUser(input: $input) {\n        clientMutationId\n        internalId\n      }\n    }\n  ", mapUserValuesToInput(user), {
    clientMutationLabel: clientMutationLabel
  });

  // eslint-disable-next-line no-param-reassign
  user.clientMutationId = mutation.clientMutationId;
  return feCore.graphqlWithVariables(mutation.operation, mutation.variables, ["ADMIN_USER_MUTATION_REQ", "ADMIN_USER_CREATE_RESP", "ADMIN_USER_MUTATION_ERR"], {
    clientMutationId: mutation.clientMutationId,
    clientMutationLabel: clientMutationLabel
  });
}
function updateUser(mm, user, clientMutationLabel) {
  var mutation = feCore.prepareMutation("\n    mutation ($input: UpdateUserMutationInput!) {\n      updateUser(input: $input) {\n        clientMutationId\n        internalId\n      }\n    }\n  ", mapUserValuesToInput(user), {
    clientMutationLabel: clientMutationLabel
  });

  // eslint-disable-next-line no-param-reassign
  user.clientMutationId = mutation.clientMutationId;
  return feCore.graphqlWithVariables(mutation.operation, mutation.variables, ["ADMIN_USER_MUTATION_REQ", "ADMIN_USER_UPDATE_RESP", "ADMIN_USER_MUTATION_ERR"], {
    clientMutationId: mutation.clientMutationId,
    clientMutationLabel: clientMutationLabel,
    userId: user.id
  });
}
function deleteUser(mm, user, clientMutationLabel) {
  var mutation = feCore.formatMutation("deleteUser", "uuids: [\"".concat(feCore.decodeId(user.id), "\"]"), clientMutationLabel);
  // eslint-disable-next-line no-param-reassign
  user.clientMutationId = mutation.clientMutationId;
  return function (dispatch) {
    dispatch(feCore.graphql(mutation.payload, ["ADMIN_USER_MUTATION_REQ", "ADMIN_USER_DELETE_RESP", "ADMIN_USER_MUTATION_ERR"], {
      clientMutationId: mutation.clientMutationId,
      clientMutationLabel: clientMutationLabel,
      userId: user.id
    }));
    dispatch(feCore.fetchMutation(mutation.clientMutationId));
  };
}
function fetchUser(mm, userId, clientMutationId) {
  var filters = [];
  if (userId) {
    filters.push("id: \"".concat(feCore.decodeId(userId), "\""));
  } else if (clientMutationId) {
    filters.push("clientMutationId: \"".concat(clientMutationId, "\""));
  }
  return feCore.graphql("\n    {\n      users(".concat(filters.join(" "), ") {\n        pageInfo { hasNextPage, hasPreviousPage, startCursor, endCursor}\n        edges {\n          node {\n            clientMutationId\n            id\n            username\n            officer {\n              id\n              hasLogin\n              phone\n              dob\n              lastName\n              otherNames\n              address\n              substitutionOfficer { id lastName otherNames code }\n              worksTo\n              officerVillages {\n                id\n                location {\n                  id\n                  name\n                  code\n                  uuid\n                  parent {\n                    id\n                    name\n                    code\n                    uuid\n                  }\n                }\n              }\n              location {\n                id\n                name\n                uuid\n                code\n                parent {\n                  id\n                  name\n                  uuid\n                  code\n                }\n              }\n            }\n            iUser {\n              id\n              phone\n              languageId\n              lastName\n              otherNames\n              roles { id name }\n              healthFacility ").concat(mm.getProjection("location.HealthFacilityPicker.projection"), "\n              validityFrom\n              validityTo\n              email\n              districts: userdistrictSet { location { id name code uuid parent { id code uuid name }}}\n            }\n            claimAdmin{\n              id\n              hasLogin\n              emailId\n              phone\n              dob\n              lastName\n              otherNames\n              healthFacility ").concat(mm.getProjection("location.HealthFacilityPicker.projection"), "\n            \n            }\n          }\n        }\n      }\n    }\n  "), "ADMIN_USER_OVERVIEW");
}
function fetchUserMutation(mm, clientMutationId) {
  var payload = feCore.formatPageQuery("mutationLogs", ["clientMutationId:\"".concat(clientMutationId, "\"")], ["id", "status", "users{coreUser{id}}"]);
  return feCore.graphql(payload, "ADMIN_USER");
}
function fetchRegionDistricts(parent) {
  var filters = ["type: \"D\""];
  if (!!parent) {
    filters.push("parent_Uuid: \"".concat(parent.uuid, "\""));
  }
  var payload = feCore.formatPageQuery("locations", filters, ["id", "uuid", "type", "code", "name", "malePopulation", "femalePopulation", "otherPopulation", "families", "clientMutationId"]);
  return feCore.graphql(payload, "LOCATION_REGION_DISTRICTS");
}
function fetchObligatoryUserFields() {
  var payload = "query userObligatoryFields {userObligatoryFields}";
  return feCore.graphql(payload, "OBLIGTORY_USER_FIELDS");
}
function fetchObligatoryEnrolmentOfficerFields() {
  var payload = "query userObligatoryFields {eoObligatoryFields}";
  return feCore.graphql(payload, "OBLIGTORY_EO_FIELDS");
}
function clearRegionDistricts() {
  return function (dispatch) {
    dispatch({
      type: "LOCATION_REGION_DISTRICTS_CLEAR"
    });
  };
}

function _createSuper$2(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$2(); return function _createSuperInternal() { var Super = _getPrototypeOf__default["default"](Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf__default["default"](this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn__default["default"](this, result); }; }
function _isNativeReflectConstruct$2() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var USER_SEARCHER_CONTRIBUTION_KEY = "user.UserSearcher";
var getHeaders = function getHeaders() {
  return ["admin.user.username", "admin.user.lastName", "admin.user.otherNames", "admin.user.email", "admin.user.phone", "admin.user.dob", ""];
};
var getSorts = function getSorts() {
  return [["username", true], ["iUser_LastName", true], ["iUser_OtherNames", true], ["iUser_email", true], ["iUser_Phone", true], ["officer__dob", false]];
};
var getAligns = function getAligns() {
  var aligns = getHeaders().map(function () {
    return null;
  });
  aligns.splice(-1, 1, "right");
  return aligns;
};
var UserSearcher = /*#__PURE__*/function (_Component) {
  _inherits__default["default"](UserSearcher, _Component);
  var _super = _createSuper$2(UserSearcher);
  function UserSearcher() {
    var _this;
    _classCallCheck__default["default"](this, UserSearcher);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "state", {
      deleteUser: null,
      params: {}
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "fetch", function (params) {
      _this.setState({
        params: params
      });
      _this.props.fetchUsersSummaries(_this.props.modulesManager, params);
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "filtersToQueryParams", function (state) {
      var prms = Object.keys(state.filters).filter(function (contrib) {
        return !!state.filters[contrib].filter;
      }).map(function (contrib) {
        return state.filters[contrib].filter;
      });
      prms.push("first: ".concat(state.pageSize));
      if (state.afterCursor) {
        prms.push("after: \"".concat(state.afterCursor, "\""));
      }
      if (state.beforeCursor) {
        prms.push("before: \"".concat(state.beforeCursor, "\""));
      }
      if (state.orderBy) {
        prms.push("orderBy: [\"".concat(state.orderBy, "\"]"));
      }
      return prms;
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "deleteUser", function (isConfirmed) {
      if (!isConfirmed) {
        _this.setState({
          deleteUser: null
        });
      } else {
        var user = _this.state.deleteUser;
        _this.setState({
          deleteUser: null
        }, /*#__PURE__*/_asyncToGenerator__default["default"]( /*#__PURE__*/_regeneratorRuntime__default["default"].mark(function _callee() {
          return _regeneratorRuntime__default["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return _this.props.deleteUser(_this.props.modulesManager, user, feCore.formatMessage(_this.props.intl, "admin.user", "deleteDialog.title"));
                case 2:
                  _this.fetch(_this.state.params);
                case 3:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        })));
      }
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "getUserItem", function (user, item) {
      return user.iUser && user.iUser[item] || user.officer && user.officer[item] || user.claimAdmin && user.claimAdmin[item];
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "itemFormatters", function () {
      var formatters = [function (u) {
        return u.username;
      }, function (u) {
        return _this.getUserItem(u, "lastName");
      }, function (u) {
        return _this.getUserItem(u, "otherNames");
      }, function (u) {
        return _this.getUserItem(u, "email") || _this.getUserItem(u, "emailId");
      }, function (u) {
        return _this.getUserItem(u, "phone");
      }, function (u) {
        return (u.claimAdmin || u.officer) && feCore.formatDateFromISO(_this.props.modulesManager, _this.props.intl, _this.getUserItem(u, "dob"));
      }, function (u) {
        return /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, /*#__PURE__*/React__default["default"].createElement(core.Tooltip, {
          title: feCore.formatMessage(_this.props.intl, "admin.user", "openNewTab")
        }, /*#__PURE__*/React__default["default"].createElement(core.IconButton, {
          onClick: function onClick() {
            return _this.props.onDoubleClick(u, true);
          }
        }, /*#__PURE__*/React__default["default"].createElement(icons.Tab, null))), _this.props.rights.includes(RIGHT_USER_DELETE) && u.validityTo ? null : /*#__PURE__*/React__default["default"].createElement(core.Tooltip, {
          title: feCore.formatMessage(_this.props.intl, "admin.user", "deleteUser.tooltip")
        }, /*#__PURE__*/React__default["default"].createElement(core.IconButton, {
          onClick: function onClick() {
            return _this.setState({
              deleteUser: u
            });
          }
        }, /*#__PURE__*/React__default["default"].createElement(icons.Delete, null))));
      }];
      return formatters;
    });
    return _this;
  }
  _createClass__default["default"](UserSearcher, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        intl = _this$props.intl,
        users = _this$props.users,
        usersPageInfo = _this$props.usersPageInfo,
        fetchingUsers = _this$props.fetchingUsers,
        fetchedUsers = _this$props.fetchedUsers,
        errorUsers = _this$props.errorUsers,
        cacheFiltersKey = _this$props.cacheFiltersKey,
        onDoubleClick = _this$props.onDoubleClick;
      return /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, this.state.deleteUser && /*#__PURE__*/React__default["default"].createElement(feCore.ConfirmDialog, {
        confirm: {
          title: feCore.formatMessage(intl, "admin.user", "deleteDialog.title"),
          message: feCore.formatMessage(intl, "admin.user", "deleteDialog.message")
        },
        onConfirm: this.deleteUser
      }), /*#__PURE__*/React__default["default"].createElement(feCore.Searcher, {
        module: "user",
        cacheFiltersKey: cacheFiltersKey,
        FilterPane: UserFilter$1,
        items: users,
        itemsPageInfo: usersPageInfo,
        fetchingItems: fetchingUsers,
        fetchedItems: fetchedUsers,
        errorItems: errorUsers,
        contributionKey: USER_SEARCHER_CONTRIBUTION_KEY,
        tableTitle: feCore.formatMessageWithValues(intl, "admin.user", "userSummaries", {
          count: usersPageInfo.totalCount
        }),
        fetch: this.fetch,
        rowIdentifier: function rowIdentifier(r) {
          return r.uuid;
        },
        filtersToQueryParams: this.filtersToQueryParams,
        defaultOrderBy: "-username",
        headers: getHeaders,
        aligns: getAligns,
        itemFormatters: this.itemFormatters,
        sorts: getSorts,
        rowDisabled: function rowDisabled(_, i) {
          return i.validityTo || i.clientMutationId;
        },
        rowLocked: function rowLocked(_, i) {
          return i.clientMutationId;
        },
        onDoubleClick: onDoubleClick
      }));
    }
  }]);
  return UserSearcher;
}(React.Component);
var mapStateToProps$2 = function mapStateToProps(state) {
  var _state$core$i_user$ri, _state$core, _state$core$i_user;
  return {
    rights: (_state$core$i_user$ri = (_state$core = state.core) === null || _state$core === void 0 ? void 0 : (_state$core$i_user = _state$core.i_user) === null || _state$core$i_user === void 0 ? void 0 : _state$core$i_user.rights) !== null && _state$core$i_user$ri !== void 0 ? _state$core$i_user$ri : [],
    users: state.admin.usersSummaries.items,
    usersPageInfo: state.admin.usersSummaries.pageInfo,
    fetchingUsers: state.admin.usersSummaries.isFetching,
    fetchedUsers: state.admin.usersSummaries.fetched,
    errorUsers: state.admin.usersSummaries.error
  };
};
var mapDispatchToProps$1 = function mapDispatchToProps(dispatch) {
  return redux.bindActionCreators({
    fetchUsersSummaries: fetchUsersSummaries,
    deleteUser: deleteUser
  }, dispatch);
};
var UserSearcher$1 = feCore.withModulesManager(reactRedux.connect(mapStateToProps$2, mapDispatchToProps$1)(reactIntl.injectIntl(UserSearcher)));

function _createSuper$1(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$1(); return function _createSuperInternal() { var Super = _getPrototypeOf__default["default"](Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf__default["default"](this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn__default["default"](this, result); }; }
function _isNativeReflectConstruct$1() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var styles$7 = function styles(theme) {
  return {
    page: theme.page,
    fab: theme.fab
  };
};
var UsersPage = /*#__PURE__*/function (_Component) {
  _inherits__default["default"](UsersPage, _Component);
  var _super = _createSuper$1(UsersPage);
  function UsersPage() {
    var _this;
    _classCallCheck__default["default"](this, UsersPage);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "onDoubleClick", function (u) {
      var newTab = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      feCore.historyPush(_this.props.modulesManager, _this.props.history, "admin.userOverview", [u.id], newTab);
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "onAdd", function () {
      feCore.historyPush(_this.props.modulesManager, _this.props.history, "admin.userNew");
    });
    return _this;
  }
  _createClass__default["default"](UsersPage, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        classes = _this$props.classes,
        rights = _this$props.rights,
        intl = _this$props.intl;
      return /*#__PURE__*/React__default["default"].createElement("div", {
        className: classes.page
      }, /*#__PURE__*/React__default["default"].createElement(UserSearcher$1, {
        cacheFiltersKey: "usersPageFiltersCache",
        onDoubleClick: this.onDoubleClick
      }), rights.includes(RIGHT_USER_ADD) && feCore.withTooltip( /*#__PURE__*/React__default["default"].createElement("div", {
        className: classes.fab
      }, /*#__PURE__*/React__default["default"].createElement(core.Fab, {
        color: "primary",
        onClick: this.onAdd
      }, /*#__PURE__*/React__default["default"].createElement(AddIcon__default["default"], null))), feCore.formatMessage(intl, "admin.user", "addNewUser.tooltip")));
    }
  }]);
  return UsersPage;
}(React.Component);
var mapStateToProps$1 = function mapStateToProps(state) {
  var _state$core$user$i_us, _state$core, _state$core$user, _state$core$user$i_us2;
  return {
    rights: (_state$core$user$i_us = (_state$core = state.core) === null || _state$core === void 0 ? void 0 : (_state$core$user = _state$core.user) === null || _state$core$user === void 0 ? void 0 : (_state$core$user$i_us2 = _state$core$user.i_user) === null || _state$core$user$i_us2 === void 0 ? void 0 : _state$core$user$i_us2.rights) !== null && _state$core$user$i_us !== void 0 ? _state$core$user$i_us : []
  };
};
var UsersPage$1 = reactIntl.injectIntl(feCore.withModulesManager(feCore.withHistory(reactRedux.connect(mapStateToProps$1)(styles$9.withTheme(styles$9.withStyles(styles$7)(UsersPage))))));

var styles$6 = function styles(theme) {
  return {
    footer: {
      marginInline: 16,
      marginBlock: 12
    },
    headerTitle: theme.table.title,
    actionCell: {
      width: 60
    },
    header: theme.table.header
  };
};
var groupVillagesByMunicipality = function groupVillagesByMunicipality(villages) {
  var result = [];
  villages === null || villages === void 0 ? void 0 : villages.forEach(function (village) {
    if (!result.find(function (x) {
      var _x$parent;
      return ((_x$parent = x.parent) === null || _x$parent === void 0 ? void 0 : _x$parent.id) === village.parent.id;
    })) {
      result.push({
        parent: village.parent,
        entities: []
      });
    }
    result.find(function (x) {
      var _x$parent2;
      return ((_x$parent2 = x.parent) === null || _x$parent2 === void 0 ? void 0 : _x$parent2.id) === village.parent.id;
    }).entities.push(village);
  });
  result.sort(function (a, b) {
    var _b$parent;
    return a.parent ? a.parent.id > ((_b$parent = b.parent) === null || _b$parent === void 0 ? void 0 : _b$parent.id) : -1;
  });
  return result;
};
var EnrolmentVillagesPicker = function EnrolmentVillagesPicker(props) {
  var location = props.location,
    modulesManager = props.modulesManager,
    readOnly = props.readOnly,
    villages = props.villages,
    onChange = props.onChange,
    classes = props.classes;
  var _useState = React.useState([]),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    items = _useState2[0],
    setItems = _useState2[1];
  var _useTranslations = feCore.useTranslations("admin.EnrolmentZonesPicker", modulesManager),
    formatMessage = _useTranslations.formatMessage;
  var handleChange = function handleChange(newItems) {
    var villageIds = newItems.reduce(function (acc, item) {
      return item.entities ? acc.concat(item.entities) : acc;
    }, []);
    onChange(villageIds);
  };
  var onRemoveRow = function onRemoveRow(row) {
    handleChange(items.filter(function (i) {
      var _i$parent, _row$parent;
      return ((_i$parent = i.parent) === null || _i$parent === void 0 ? void 0 : _i$parent.id) !== ((_row$parent = row.parent) === null || _row$parent === void 0 ? void 0 : _row$parent.id);
    }));
  };
  React.useEffect(function () {
    setItems(groupVillagesByMunicipality(villages));
  }, [villages]);
  var onInsertRow = function onInsertRow() {
    setItems([].concat(_toConsumableArray__default["default"](items), [{}]));
  };
  var onSelectParent = function onSelectParent(item, parent) {
    // eslint-disable-next-line no-param-reassign
    item.parent = parent;
    setItems(_toConsumableArray__default["default"](items));
  };
  var onVillagesChange = function onVillagesChange(item, entities) {
    // eslint-disable-next-line no-param-reassign
    item.entities = entities;
    handleChange(items);
  };

  // Only display options for municipalities not already present.
  var filterParents = function filterParents(options) {
    return options.filter(function (p) {
      return !items.some(function (i) {
        var _i$parent2;
        return ((_i$parent2 = i.parent) === null || _i$parent2 === void 0 ? void 0 : _i$parent2.id) === p.id;
      });
    });
  };
  return /*#__PURE__*/React__default["default"].createElement(core.TableContainer, {
    component: core.Paper
  }, /*#__PURE__*/React__default["default"].createElement(core.Table, {
    size: "small"
  }, /*#__PURE__*/React__default["default"].createElement(core.TableHead, {
    className: classes.header
  }, /*#__PURE__*/React__default["default"].createElement(core.TableRow, {
    className: classes.headerTitle
  }, /*#__PURE__*/React__default["default"].createElement(core.TableCell, null, formatMessage("table.municipality")), /*#__PURE__*/React__default["default"].createElement(core.TableCell, null, formatMessage("table.villages")), /*#__PURE__*/React__default["default"].createElement(core.TableCell, null))), /*#__PURE__*/React__default["default"].createElement(core.TableBody, null, items.map(function (item) {
    var _item$parent;
    return /*#__PURE__*/React__default["default"].createElement(core.TableRow, {
      key: (_item$parent = item.parent) === null || _item$parent === void 0 ? void 0 : _item$parent.id
    }, /*#__PURE__*/React__default["default"].createElement(core.TableCell, null, item.parent ? "".concat(item.parent.code, " ").concat(item.parent.name) : /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
      pubRef: "location.LocationPicker",
      parentLocation: location,
      onChange: function onChange(parent) {
        return onSelectParent(item, parent);
      },
      required: true,
      filterOptions: filterParents,
      value: item.parent,
      locationLevel: 2
    })), /*#__PURE__*/React__default["default"].createElement(core.TableCell, null, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
      fullWidth: true,
      pubRef: "location.LocationPicker",
      parentLocation: item.parent,
      readOnly: readOnly,
      required: true,
      multiple: true,
      value: item.entities,
      onChange: function onChange(value) {
        return onVillagesChange(item, value);
      },
      filterSelectedOptions: true,
      locationLevel: 3
    })), /*#__PURE__*/React__default["default"].createElement(core.TableCell, {
      className: classes.actionCell
    }, /*#__PURE__*/React__default["default"].createElement(core.IconButton, {
      disabled: readOnly,
      onClick: function onClick() {
        return onRemoveRow(item);
      }
    }, /*#__PURE__*/React__default["default"].createElement(DeleteIcon__default["default"], null))));
  })), /*#__PURE__*/React__default["default"].createElement(core.TableFooter, null, /*#__PURE__*/React__default["default"].createElement(core.Button, {
    disabled: readOnly,
    variant: "contained",
    onClick: onInsertRow,
    startIcon: /*#__PURE__*/React__default["default"].createElement(AddIcon__default["default"], null),
    className: classes.footer
  }, formatMessage("table.newRow")))));
};
var enhance$4 = feCore.combine(feCore.withModulesManager, styles$9.withTheme, styles$9.withStyles(styles$6));
var EnrolmentVillagesPicker$1 = enhance$4(EnrolmentVillagesPicker);

function ownKeys$5(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$5(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys$5(Object(source), !0).forEach(function (key) { _defineProperty__default["default"](target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$5(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var styles$5 = function styles(theme) {
  return {
    item: theme.paper.item,
    paper: theme.paper.paper,
    title: theme.paper.title
  };
};
var EnrolmentOfficerFormPanel = function EnrolmentOfficerFormPanel(props) {
  var _edited$userTypes, _edited$worksTo, _edited$address, _edited$location$pare, _edited$location, _edited$location2, _edited$location3;
  var edited = props.edited,
    classes = props.classes,
    modulesManager = props.modulesManager,
    onEditedChanged = props.onEditedChanged,
    readOnly = props.readOnly;
  var _useTranslations = feCore.useTranslations("admin.EnrolmentOfficerFormPanel", modulesManager),
    formatMessage = _useTranslations.formatMessage;
  var isEnabled = (_edited$userTypes = edited.userTypes) === null || _edited$userTypes === void 0 ? void 0 : _edited$userTypes.includes(ENROLMENT_OFFICER_USER_TYPE);
  var has_role = !!edited.roles ? edited.roles.filter(function (x) {
    return x.isSystem == 1;
  }).length != 0 : false;
  if (isEnabled) {
    var _useGraphqlQuery = feCore.useGraphqlQuery("\n      query UserRolesPicker ($system_id: Int) {\n        role(systemRoleId: $system_id) {\n          edges {\n            node {\n              id name isSystem\n            }\n          }\n        }\n      }\n    ", {
        system_id: 1
      } // EO System Role is 1
      ),
      isLoading = _useGraphqlQuery.isLoading,
      data = _useGraphqlQuery.data;
      _useGraphqlQuery.error;
    var isValid = !isLoading;
    React.useEffect(function () {
      if (isValid & isEnabled & !has_role) {
        var role = data.role.edges[0].node;
        var roles = !!edited.roles ? edited.roles : [];
        roles.push(role);
        edited.roles = roles;
        onEditedChanged(edited);
      }
    }, [isValid]);
  }
  return /*#__PURE__*/React__default["default"].createElement(core.Paper, {
    className: classes.paper
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12,
    className: classes.title
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    container: true,
    justifyContent: "space-between",
    alignItems: "center"
  }, /*#__PURE__*/React__default["default"].createElement(core.Typography, {
    variant: "h6"
  }, formatMessage("title")), (!edited.id || !isEnabled) && /*#__PURE__*/React__default["default"].createElement(core.Switch, {
    color: "secondary",
    disabled: readOnly,
    checked: isEnabled,
    onChange: function onChange() {
      return onEditedChanged(toggleUserType(edited, ENROLMENT_OFFICER_USER_TYPE));
    }
  }))), isEnabled && /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    container: true
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "core.DatePicker",
    value: edited === null || edited === void 0 ? void 0 : edited.birthDate,
    module: "admin",
    label: "user.dob",
    readOnly: readOnly,
    onChange: function onChange(birthDate) {
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        birthDate: birthDate
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "admin.EnrolmentOfficerPicker",
    module: "admin",
    readOnly: readOnly,
    label: formatMessage("substitutionOfficer"),
    value: edited.substitutionOfficer,
    onChange: function onChange(substitutionOfficer) {
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        substitutionOfficer: substitutionOfficer
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "core.DatePicker",
    value: (_edited$worksTo = edited === null || edited === void 0 ? void 0 : edited.worksTo) !== null && _edited$worksTo !== void 0 ? _edited$worksTo : "",
    module: "admin",
    label: "user.worksTo",
    readOnly: readOnly,
    onChange: function onChange(worksTo) {
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        worksTo: worksTo
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    label: "user.address",
    multiline: true,
    rows: 2,
    variant: "outlined",
    readOnly: readOnly,
    value: (_edited$address = edited === null || edited === void 0 ? void 0 : edited.address) !== null && _edited$address !== void 0 ? _edited$address : "",
    onChange: function onChange(address) {
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        address: address
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "location.RegionPicker",
    value: (_edited$location$pare = (_edited$location = edited.location) === null || _edited$location === void 0 ? void 0 : _edited$location.parent) !== null && _edited$location$pare !== void 0 ? _edited$location$pare : edited.location,
    required: true,
    readOnly: readOnly,
    withNull: true,
    onChange: function onChange(location) {
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        location: location
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    region: ((_edited$location2 = edited.location) === null || _edited$location2 === void 0 ? void 0 : _edited$location2.parent) || edited.location,
    value: (_edited$location3 = edited.location) !== null && _edited$location3 !== void 0 && _edited$location3.parent ? edited.location : null,
    pubRef: "location.DistrictPicker",
    required: true,
    withNull: true,
    readOnly: readOnly,
    onChange: function onChange(location) {
      var _edited$location4;
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        location: location || ((_edited$location4 = edited.location) === null || _edited$location4 === void 0 ? void 0 : _edited$location4.parent)
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(EnrolmentVillagesPicker$1, {
    readOnly: readOnly,
    location: edited.location,
    villages: edited.officerVillages,
    onChange: function onChange(officerVillages) {
      return onEditedChanged(_objectSpread$5(_objectSpread$5({}, edited), {}, {
        officerVillages: officerVillages
      }));
    }
  })))));
};
var enhance$3 = feCore.combine(feCore.withModulesManager, styles$9.withTheme, styles$9.withStyles(styles$5));
var EnrolmentOfficerFormPanel$1 = enhance$3(EnrolmentOfficerFormPanel);

function ownKeys$4(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$4(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys$4(Object(source), !0).forEach(function (key) { _defineProperty__default["default"](target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$4(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var styles$4 = function styles(theme) {
  return {
    item: theme.paper.item,
    paper: theme.paper.paper,
    title: theme.paper.title
  };
};
var ClaimAdministratorFormPanel = function ClaimAdministratorFormPanel(props) {
  var _edited$userTypes;
  var edited = props.edited,
    classes = props.classes,
    modulesManager = props.modulesManager,
    onEditedChanged = props.onEditedChanged,
    readOnly = props.readOnly;
  var _useTranslations = feCore.useTranslations("admin.ClaimAdministratorFormPanel", modulesManager),
    formatMessage = _useTranslations.formatMessage;
  var isEnabled = (_edited$userTypes = edited.userTypes) === null || _edited$userTypes === void 0 ? void 0 : _edited$userTypes.includes(CLAIM_ADMIN_USER_TYPE);
  var has_role = !!edited.roles ? edited.roles.filter(function (x) {
    return x.isSystem == 256;
  }).length != 0 : false;
  if (isEnabled) {
    var _useGraphqlQuery = feCore.useGraphqlQuery("\n      query UserRolesPicker ($system_id: Int) {\n        role(systemRoleId: $system_id) {\n          edges {\n            node {\n              id name isSystem\n            }\n          }\n        }\n      }\n    ", {
        system_id: 256
      } // Claim Admin System Role is 256
      ),
      isLoading = _useGraphqlQuery.isLoading,
      data = _useGraphqlQuery.data;
      _useGraphqlQuery.error;
    var isValid = !isLoading;
    React.useEffect(function () {
      if (isValid & isEnabled & !has_role) {
        var role = data.role.edges[0].node;
        var roles = !!edited.roles ? edited.roles : [];
        roles.push(role);
        edited.roles = roles;
        onEditedChanged(edited);
      }
    }, [isValid]);
  }
  return /*#__PURE__*/React__default["default"].createElement(core.Paper, {
    className: classes.paper
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12,
    className: classes.title
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    container: true,
    justifyContent: "space-between",
    alignItems: "center"
  }, /*#__PURE__*/React__default["default"].createElement(core.Typography, {
    variant: "h6"
  }, formatMessage("title")), (!edited.id || !isEnabled) && /*#__PURE__*/React__default["default"].createElement(core.Switch, {
    color: "secondary",
    disabled: readOnly,
    checked: isEnabled,
    onChange: function onChange() {
      return onEditedChanged(toggleUserType(edited, CLAIM_ADMIN_USER_TYPE));
    }
  }))), isEnabled && /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    container: true
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "core.DatePicker",
    value: edited === null || edited === void 0 ? void 0 : edited.birthDate,
    module: "admin",
    label: "user.dob",
    readOnly: readOnly,
    onChange: function onChange(birthDate) {
      return onEditedChanged(_objectSpread$4(_objectSpread$4({}, edited), {}, {
        birthDate: birthDate
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "location.HealthFacilityPicker",
    value: edited === null || edited === void 0 ? void 0 : edited.healthFacility,
    required: true,
    module: "admin",
    readOnly: readOnly,
    onChange: function onChange(healthFacility) {
      return onEditedChanged(_objectSpread$4(_objectSpread$4({}, edited), {}, {
        healthFacility: healthFacility
      }));
    }
  })))));
};
var enhance$2 = feCore.combine(feCore.withModulesManager, styles$9.withTheme, styles$9.withStyles(styles$4));
var ClaimAdministratorFormPanel$1 = enhance$2(ClaimAdministratorFormPanel);

function ownKeys$3(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$3(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys$3(Object(source), !0).forEach(function (key) { _defineProperty__default["default"](target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$3(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var styles$3 = function styles(theme) {
  return {
    tableTitle: theme.table.title,
    item: theme.paper.item,
    fullHeight: {
      height: "100%"
    },
    sectionHeader: _objectSpread$3(_objectSpread$3({}, theme.paper.item), {}, {
      paddingBottom: 0
    }),
    sectionTitle: theme.typography.title
  };
};
var UserMasterPanel = function UserMasterPanel(props) {
  var _edited$username, _edited$otherNames, _edited$lastName, _edited$userTypes, _edited$userTypes2, _edited$email, _edited$userTypes3, _edited$userTypes4, _edited$phoneNumber, _edited$roles;
  var classes = props.classes,
    edited = props.edited,
    readOnly = props.readOnly,
    onEditedChanged = props.onEditedChanged,
    modulesManager = props.modulesManager,
    obligatoryUserFields = props.obligatoryUserFields,
    obligatoryEOFields = props.obligatoryEOFields;
  var _useTranslations = feCore.useTranslations("admin", modulesManager),
    formatMessage = _useTranslations.formatMessage;
  return /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    container: true,
    direction: "row"
  }, /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    required: true,
    label: "user.username",
    readOnly: Boolean(edited.id) || readOnly,
    value: (_edited$username = edited === null || edited === void 0 ? void 0 : edited.username) !== null && _edited$username !== void 0 ? _edited$username : "",
    onChange: function onChange(username) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        username: username
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    label: "user.givenNames",
    required: true,
    readOnly: readOnly,
    value: (_edited$otherNames = edited === null || edited === void 0 ? void 0 : edited.otherNames) !== null && _edited$otherNames !== void 0 ? _edited$otherNames : "",
    onChange: function onChange(otherNames) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        otherNames: otherNames
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    label: "user.lastName",
    required: true,
    readOnly: readOnly,
    value: (_edited$lastName = edited === null || edited === void 0 ? void 0 : edited.lastName) !== null && _edited$lastName !== void 0 ? _edited$lastName : "",
    onChange: function onChange(lastName) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        lastName: lastName
      }));
    }
  })), !((obligatoryUserFields === null || obligatoryUserFields === void 0 ? void 0 : obligatoryUserFields.email) == "H" || (_edited$userTypes = edited.userTypes) !== null && _edited$userTypes !== void 0 && _edited$userTypes.includes(ENROLMENT_OFFICER_USER_TYPE) && (obligatoryEOFields === null || obligatoryEOFields === void 0 ? void 0 : obligatoryEOFields.email) == "H") && /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    type: "email",
    label: "user.email",
    required: (obligatoryUserFields === null || obligatoryUserFields === void 0 ? void 0 : obligatoryUserFields.email) == "M" || ((_edited$userTypes2 = edited.userTypes) === null || _edited$userTypes2 === void 0 ? void 0 : _edited$userTypes2.includes(ENROLMENT_OFFICER_USER_TYPE)) && (obligatoryEOFields === null || obligatoryEOFields === void 0 ? void 0 : obligatoryEOFields.email) == "M",
    readOnly: readOnly,
    value: (_edited$email = edited === null || edited === void 0 ? void 0 : edited.email) !== null && _edited$email !== void 0 ? _edited$email : "",
    onChange: function onChange(email) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        email: email
      }));
    }
  })), !((obligatoryUserFields === null || obligatoryUserFields === void 0 ? void 0 : obligatoryUserFields.phone) == "H" || (_edited$userTypes3 = edited.userTypes) !== null && _edited$userTypes3 !== void 0 && _edited$userTypes3.includes(ENROLMENT_OFFICER_USER_TYPE) && (obligatoryEOFields === null || obligatoryEOFields === void 0 ? void 0 : obligatoryEOFields.phone) == "H") && /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    type: "phone",
    label: "user.phone",
    required: (obligatoryUserFields === null || obligatoryUserFields === void 0 ? void 0 : obligatoryUserFields.phone) == "M" || ((_edited$userTypes4 = edited.userTypes) === null || _edited$userTypes4 === void 0 ? void 0 : _edited$userTypes4.includes(ENROLMENT_OFFICER_USER_TYPE)) && (obligatoryEOFields === null || obligatoryEOFields === void 0 ? void 0 : obligatoryEOFields.phone) == "M",
    readOnly: readOnly,
    value: (_edited$phoneNumber = edited === null || edited === void 0 ? void 0 : edited.phoneNumber) !== null && _edited$phoneNumber !== void 0 ? _edited$phoneNumber : "",
    onChange: function onChange(phoneNumber) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        phoneNumber: phoneNumber
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "location.HealthFacilityPicker",
    value: edited === null || edited === void 0 ? void 0 : edited.healthFacility,
    district: edited.districts,
    module: "admin",
    readOnly: readOnly,
    required: edited.userTypes.includes(CLAIM_ADMIN_USER_TYPE) /* This field is also present in the claim administrator panel */,

    onChange: function onChange(healthFacility) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        healthFacility: healthFacility
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 6,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "admin.UserRolesPicker",
    required: true,
    value: (_edited$roles = edited === null || edited === void 0 ? void 0 : edited.roles) !== null && _edited$roles !== void 0 ? _edited$roles : [],
    module: "admin",
    readOnly: readOnly,
    onChange: function onChange(roles) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        roles: roles
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 2,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "location.LocationPicker",
    locationLevel: 0,
    value: edited.region,
    onChange: function onChange(region) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        region: region
      }));
    },
    readOnly: readOnly,
    required: true,
    multiple: true,
    withLabel: true,
    label: formatMessage("user.regions")
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "location.LocationPicker",
    locationLevel: 1,
    value: edited.districts,
    onChange: function onChange(districts) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        districts: districts
      }));
    },
    readOnly: readOnly,
    required: true,
    multiple: true,
    withLabel: true,
    label: formatMessage("user.districts")
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 12,
    className: classes.sectionHeader
  }, /*#__PURE__*/React__default["default"].createElement(core.Typography, {
    className: classes.sectionTitle
  }, formatMessage("UserMasterPanel.loginDetailsTitle")), /*#__PURE__*/React__default["default"].createElement(core.Divider, {
    variant: "fullWidth"
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.PublishedComponent, {
    pubRef: "core.LanguagePicker",
    module: "admin",
    label: "user.language",
    readOnly: readOnly,
    required: true,
    withNull: true,
    nullLabel: formatMessage("UserMasterPanel.language.null"),
    value: edited === null || edited === void 0 ? void 0 : edited.language,
    onChange: function onChange(language) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        language: language
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    type: "password",
    label: "user.newPassword",
    readOnly: readOnly,
    value: "",
    onChange: function onChange(password) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        password: password
      }));
    }
  })), /*#__PURE__*/React__default["default"].createElement(core.Grid, {
    item: true,
    xs: 4,
    className: classes.item
  }, /*#__PURE__*/React__default["default"].createElement(feCore.TextInput, {
    module: "admin",
    type: "password",
    label: "user.confirmNewPassword",
    required: edited.password,
    readOnly: readOnly,
    value: "",
    onChange: function onChange(confirmPassword) {
      return onEditedChanged(_objectSpread$3(_objectSpread$3({}, edited), {}, {
        confirmPassword: confirmPassword
      }));
    }
  })));
};
var enhance$1 = feCore.combine(feCore.withModulesManager, styles$9.withTheme, styles$9.withStyles(styles$3));
var UserMasterPanel$1 = enhance$1(UserMasterPanel);

function ownKeys$2(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$2(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys$2(Object(source), !0).forEach(function (key) { _defineProperty__default["default"](target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$2(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf__default["default"](Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf__default["default"](this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn__default["default"](this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var styles$2 = function styles(theme) {
  return {
    lockedPage: theme.page.locked
  };
};
var USER_OVERVIEW_MUTATIONS_KEY = "user.UserOverview.mutations";
var setupState = function setupState(props) {
  return {
    isLocked: false,
    user: !props.userId ? {
      userTypes: [INTERACTIVE_USER_TYPE]
    } : props.user
  };
};
var UserForm = /*#__PURE__*/function (_Component) {
  _inherits__default["default"](UserForm, _Component);
  var _super = _createSuper(UserForm);
  function UserForm(props) {
    var _this;
    _classCallCheck__default["default"](this, UserForm);
    _this = _super.call(this, props);
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "reload", function () {
      var clientMutationId = _this.props.mutation.clientMutationId;
      if (clientMutationId) {
        _this.props.fetchUserMutation(_this.props.modulesManager, clientMutationId).then(function (res) {
          var mutationLogs = feCore.parseData(res.payload.data.mutationLogs);
          if (mutationLogs && mutationLogs[0] && mutationLogs[0].users && mutationLogs[0].users[0] && mutationLogs[0].users[0].coreUser) {
            var id = feCore.parseData(res.payload.data.mutationLogs)[0].users[0].coreUser.id;
            if (id) {
              feCore.historyPush(_this.props.modulesManager, _this.props.history, "admin.userOverview", [id]);
            }
          }
        });
      }
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "canSave", function () {
      var _user$roles, _user$districts, _user$userTypes, _user$userTypes2, _this$props$obligator, _user$userTypes3, _this$props$obligator2, _this$props$obligator3, _user$userTypes4, _this$props$obligator4;
      var user = _this.state.user;
      if (!user) return false;
      if (!(user.lastName && user.otherNames && user.username && (_user$roles = user.roles) !== null && _user$roles !== void 0 && _user$roles.length && ((_user$districts = user.districts) === null || _user$districts === void 0 ? void 0 : _user$districts.length) > 0 && user.language)) return false;
      if (user.password && user.password !== user.confirmPassword) return false;
      if ((_user$userTypes = user.userTypes) !== null && _user$userTypes !== void 0 && _user$userTypes.includes(CLAIM_ADMIN_USER_TYPE) && !user.healthFacility) return false;
      if ((_user$userTypes2 = user.userTypes) !== null && _user$userTypes2 !== void 0 && _user$userTypes2.includes(ENROLMENT_OFFICER_USER_TYPE) && !user.officerVillages) return false;
      if ((((_this$props$obligator = _this.props.obligatory_user_fields) === null || _this$props$obligator === void 0 ? void 0 : _this$props$obligator.email) == 'M' || (_user$userTypes3 = user.userTypes) !== null && _user$userTypes3 !== void 0 && _user$userTypes3.includes(ENROLMENT_OFFICER_USER_TYPE) && ((_this$props$obligator2 = _this.props.obligatory_eo_fields) === null || _this$props$obligator2 === void 0 ? void 0 : _this$props$obligator2.email) == 'M') && !user.email) return false;
      if ((((_this$props$obligator3 = _this.props.obligatory_user_fields) === null || _this$props$obligator3 === void 0 ? void 0 : _this$props$obligator3.phone) == 'M' || (_user$userTypes4 = user.userTypes) !== null && _user$userTypes4 !== void 0 && _user$userTypes4.includes(ENROLMENT_OFFICER_USER_TYPE) && ((_this$props$obligator4 = _this.props.obligatory_eo_fields) === null || _this$props$obligator4 === void 0 ? void 0 : _this$props$obligator4.phone) == 'M') && !user.phoneNumber) return false;
      return true;
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "save", function (user) {
      _this.setState({
        isLocked: true
      });
      _this.props.save(user);
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "onEditedChanged", function (user) {
      if (!!user.region) {
        user.region.forEach(function (region) {
          _this.props.fetchRegionDistricts(region);
        });
      } else {
        _this.props.clearRegionDistricts();
      }
      _this.setState({
        user: user
      });
    });
    _defineProperty__default["default"](_assertThisInitialized__default["default"](_this), "onActionToConfirm", function (title, message, confirmedAction) {
      _this.setState({
        confirmedAction: confirmedAction
      }, _this.props.coreConfirm(title, message));
    });
    _this.state = setupState(props);
    return _this;
  }
  _createClass__default["default"](UserForm, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.userId) {
        this.props.fetchUser(this.props.modulesManager, this.props.userId);
      }
      if (!this.state.obligatory_user_fields) {
        this.props.fetchObligatoryUserFields();
      }
      if (!this.state.obligatory_eo_fields) {
        this.props.fetchObligatoryEnrolmentOfficerFields();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.region_districts != this.props.region_districts) {
        if (!!this.props.region_districts) {
          var combined = [].concat(_toConsumableArray__default["default"](!!this.state.user.districts ? this.state.user.districts : []), _toConsumableArray__default["default"](this.props.region_districts));
          var no_duplicates = _toConsumableArray__default["default"](new Map(combined.map(function (x) {
            return [x.uuid, x];
          })).values());
          this.state.user.districts = no_duplicates;
          this.state.user.region = [];
          this.setState(function (state, props) {
            return {
              user: _objectSpread$2({}, state.user)
            };
          });
        }
      }
      if (!prevProps.fetchedUser && this.props.fetchedUser) {
        this.setState(setupState(this.props));
      } else if (prevProps.userId && !this.props.userId) {
        this.setState(setupState(this.props));
      } else if (prevProps.submittingMutation && !this.props.submittingMutation) {
        this.props.journalize(this.props.mutation);
        this.setState(function (state, props) {
          return {
            user: _objectSpread$2(_objectSpread$2({}, state.user), {}, {
              clientMutationId: props.mutation.clientMutationId
            })
          };
        });
      } else if (prevProps.confirmed !== this.props.confirmed && !!this.props.confirmed && !!this.state.confirmedAction) {
        this.state.confirmedAction();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        modulesManager = _this$props.modulesManager,
        classes = _this$props.classes,
        state = _this$props.state,
        rights = _this$props.rights,
        userId = _this$props.userId,
        fetchingUser = _this$props.fetchingUser,
        errorUser = _this$props.errorUser,
        _this$props$readOnly = _this$props.readOnly,
        readOnly = _this$props$readOnly === void 0 ? false : _this$props$readOnly,
        add = _this$props.add,
        save = _this$props.save,
        back = _this$props.back;
        _this$props.region_districts;
        var obligatory_user_fields = _this$props.obligatory_user_fields,
        obligatory_eo_fields = _this$props.obligatory_eo_fields;
      var user = this.state.user;
      if (!rights.includes(RIGHT_USERS)) return null;
      var isInMutation = (user === null || user === void 0 ? void 0 : user.clientMutationId) || modulesManager.getContribs(USER_OVERVIEW_MUTATIONS_KEY).some(function (mutation) {
        return mutation(state);
      });
      var actions = [!userId && {
        doIt: this.reload,
        icon: /*#__PURE__*/React__default["default"].createElement(ReplayIcon__default["default"], null),
        onlyIfDirty: !readOnly && !isInMutation
      }].filter(Boolean);
      return /*#__PURE__*/React__default["default"].createElement("div", {
        className: isInMutation ? classes.lockedPage : null
      }, /*#__PURE__*/React__default["default"].createElement(feCore.Helmet, {
        title: feCore.formatMessageWithValues(this.props.intl, "admin.user", "UserOverview.title", {
          label: ""
        })
      }), /*#__PURE__*/React__default["default"].createElement(feCore.ProgressOrError, {
        progress: fetchingUser,
        error: errorUser
      }), (!userId || (user === null || user === void 0 ? void 0 : user.id) === userId) && /*#__PURE__*/React__default["default"].createElement(feCore.Form, {
        module: "user",
        title: userId ? "admin.user.UserOverview.title" : "admin.user.UserOverview.newTitle",
        edited_id: userId,
        edited: user,
        back: back,
        add: add,
        readOnly: readOnly || isInMutation || (user === null || user === void 0 ? void 0 : user.validityTo),
        actions: actions,
        HeadPanel: UserMasterPanel$1,
        Panels: [EnrolmentOfficerFormPanel$1, ClaimAdministratorFormPanel$1],
        user: user,
        onEditedChanged: this.onEditedChanged,
        canSave: this.canSave,
        save: save ? this.save : null,
        onActionToConfirm: this.onActionToConfirm,
        obligatory_user_fields: obligatory_user_fields,
        obligatory_eo_fields: obligatory_eo_fields
      }));
    }
  }]);
  return UserForm;
}(React.Component);
var mapStateToProps = function mapStateToProps(state) {
  var _state$core$user$i_us, _state$core, _state$core$user, _state$core$user$i_us2;
  return {
    rights: (_state$core$user$i_us = (_state$core = state.core) === null || _state$core === void 0 ? void 0 : (_state$core$user = _state$core.user) === null || _state$core$user === void 0 ? void 0 : (_state$core$user$i_us2 = _state$core$user.i_user) === null || _state$core$user$i_us2 === void 0 ? void 0 : _state$core$user$i_us2.rights) !== null && _state$core$user$i_us !== void 0 ? _state$core$user$i_us : [],
    fetchingUser: state.admin.fetchingUser,
    errorUser: state.admin.errorUser,
    fetchedUser: state.admin.fetchedUser,
    submittingMutation: state.admin.submittingMutation,
    mutation: state.admin.mutation,
    user: state.admin.user,
    region_districts: state.admin.reg_dst,
    confirmed: state.core.confirmed,
    obligatory_user_fields: state.admin.obligatory_user_fields,
    obligatory_eo_fields: state.admin.obligatory_eo_fields
  };
};
var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return redux.bindActionCreators({
    fetchUser: fetchUser,
    createUser: createUser,
    fetchUserMutation: fetchUserMutation,
    fetchRegionDistricts: fetchRegionDistricts,
    clearRegionDistricts: clearRegionDistricts,
    fetchObligatoryUserFields: fetchObligatoryUserFields,
    fetchObligatoryEnrolmentOfficerFields: fetchObligatoryEnrolmentOfficerFields,
    journalize: feCore.journalize,
    coreConfirm: feCore.coreConfirm
  }, dispatch);
};
var UserForm$1 = feCore.withHistory(feCore.withModulesManager(reactRedux.connect(mapStateToProps, mapDispatchToProps)(reactIntl.injectIntl(styles$9.withTheme(styles$9.withStyles(styles$2)(UserForm))))));

var styles$1 = function styles(theme) {
  return {
    page: theme.page
  };
};
var UserPage = function UserPage(props) {
  var modulesManager = props.modulesManager,
    history = props.history,
    match = props.match,
    classes = props.classes;
  var rights = reactRedux.useSelector(function (state) {
    var _state$core$user$i_us, _state$core, _state$core$user, _state$core$user$i_us2;
    return (_state$core$user$i_us = (_state$core = state.core) === null || _state$core === void 0 ? void 0 : (_state$core$user = _state$core.user) === null || _state$core$user === void 0 ? void 0 : (_state$core$user$i_us2 = _state$core$user.i_user) === null || _state$core$user$i_us2 === void 0 ? void 0 : _state$core$user$i_us2.rights) !== null && _state$core$user$i_us !== void 0 ? _state$core$user$i_us : [];
  });
  var _useState = React.useState(Date.now()),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    resetKey = _useState2[0],
    setResetKey = _useState2[1];
  var _useTranslations = feCore.useTranslations("admin", modulesManager),
    formatMessageWithValues = _useTranslations.formatMessageWithValues;
  var dispatch = reactRedux.useDispatch();
  var add = function add() {
    setResetKey(Date.now());
    feCore.historyPush(modulesManager, history, "admin.userNew");
  };
  var save = function save(user) {
    if (!user.id) {
      dispatch(createUser(modulesManager, user, formatMessageWithValues("user.createUser.mutationLabel")));
    } else {
      dispatch(updateUser(modulesManager, user, formatMessageWithValues("user.updateUser.mutationLabel")));
    }
  };
  return /*#__PURE__*/React__default["default"].createElement("div", {
    className: classes.page
  }, /*#__PURE__*/React__default["default"].createElement(UserForm$1, {
    key: resetKey,
    readOnly: match.params.user_id ? !rights.includes(RIGHT_USER_EDIT) : !rights.includes(RIGHT_USER_ADD),
    userId: match.params.user_id,
    back: function back() {
      return feCore.historyPush(modulesManager, history, "admin.users");
    },
    add: rights.includes(RIGHT_USER_ADD) ? add : null,
    save: rights.includes(RIGHT_USER_EDIT) ? save : null
  }));
};
var enhance = feCore.combine(feCore.withHistory, feCore.withModulesManager, styles$9.withTheme, styles$9.withStyles(styles$1));
var UserPage$1 = enhance(UserPage);

var messagesEn = {
	"admin.UserPicker.label": "User",
	"admin.UserPicker.null": "Any",
	"admin.mainMenu": "Administration",
	"admin.menu.claimAdministrators": "Claim Administrators",
	"admin.menu.enrollmentOfficers": "Enrollment Officers",
	"admin.menu.healthFacilities": "Health Facilities",
	"admin.menu.locations": "Locations",
	"admin.menu.medicalItems": "Medical Items",
	"admin.menu.medicalItemsPrices": "Medical Items Price Lists",
	"admin.menu.medicalServices": "Medical Services",
	"admin.menu.medicalServicesPrices": "Medical Services Price Lists",
	"admin.menu.payers": "Payers",
	"admin.menu.products": "Products",
	"admin.menu.users": "Users",
	"admin.menu.usersProfiles": "Users Profiles",
	"admin.showHistory": "Show historical values",
	"admin.user.CreateUser.mutationLabel": "Create user",
	"admin.user.UserOverview.newTitle": "New User",
	"admin.user.UserOverview.title": "User Details",
	"admin.user.address": "Address",
	"admin.user.addNewUser.tooltip": "Add new user",
	"admin.user.addNewUserTooltip": "Add new user",
	"admin.user.createUser.mutationLabel": "Create user",
	"admin.user.deleteDialog.message": "Are you sure you want to delete this user?",
	"admin.user.deleteDialog.title": "Delete user",
	"admin.user.deleteDialog.yes.button": "Yes",
	"admin.user.deleteUser.tooltip": "Delete user",
	"admin.user.deleteUserDialog.message": "Are you sure you want to delete this user?",
	"admin.user.dob": "Birth date",
	"admin.user.dobFrom": "Birth date from",
	"admin.user.dobTo": "Birth date to",
	"admin.user.email": "Email",
	"admin.user.districts": "Districts",
	"admin.user.regions": "Regions",
	"admin.user.lastName": "Last name",
	"admin.user.language": "Interface Language",
	"admin.user.openNewTab": "Open in new tab",
	"admin.user.otherNames": "Other names",
	"admin.user.givenNames": "Given names",
	"admin.user.password": "Password",
	"admin.user.newPassword": "New Password",
	"admin.user.confirmNewPassword": "Confirm Password",
	"admin.user.phone": "Phone",
	"admin.user.updateUser.mutationLabel": "Update user",
	"admin.user.userRoles.placeholder": "Select User Role(s)",
	"admin.user.userRoles": "User role(s)",
	"admin.user.userSummaries": "{count} user(s) found",
	"admin.user.userTypes": "User type(s)",
	"admin.user.userTypes.CLAIM_ADMIN": "Claim admin",
	"admin.user.userTypes.INTERACTIVE": "Interactive",
	"admin.user.userTypes.OFFICER": "Enrolment Officer",
	"admin.user.userTypes.noOptions": "No user type found",
	"admin.user.userTypes.none": " ",
	"admin.user.userTypes.null": "Any",
	"admin.user.username": "User name",
	"admin.user.worksTo": "Works to",
	"admin.EnrolmentOfficerFormPanel.title": "Enrolment Officer",
	"admin.ClaimAdministratorFormPanel.title": "Claim Administrator",
	"admin.InteractiveUserFormPanel.title": "Interactive User",
	"admin.EnrolmentZonesPicker.table.municipality": "Municipality",
	"admin.EnrolmentZonesPicker.table.newRow": "Add a row",
	"admin.EnrolmentZonesPicker.table.villages": "Villages",
	"admin.EnrolmentZonesPicker.table.addButton": "Add a row",
	"admin.EnrolmentOfficerFormPanel.substitutionOfficer": "Substitution Officer",
	"admin.UserPicker.loadingText": "Loading...",
	"admin.UserPicker.clearText": "Clear",
	"admin.UserPicker.openText": "Open",
	"admin.UserPicker.closeText": "Close",
	"admin.UserMasterPanel.loginDetailsTitle": "Login Details",
	"admin.UserMasterPanel.language.null": "Select a language",
	"admin.EnrolmentOfficerPicker.label": "Select an Officer",
	"admin.EnrolmentOfficerPicker.loadingText": "Loading...",
	"admin.EnrolmentOfficerPicker.clearText": "Clear",
	"admin.EnrolmentOfficerPicker.openText": "Open",
	"admin.EnrolmentOfficerPicker.closeText": "Close"
};

var styles = function styles(theme) {
  return {
    label: {
      color: theme.palette.primary.main
    }
  };
};
var formatSuggestion$1 = function formatSuggestion(p) {
  var _p$iUser, _p$iUser2;
  if (!p) return "?";
  return [p.username, (_p$iUser = p.iUser) === null || _p$iUser === void 0 ? void 0 : _p$iUser.lastName, (_p$iUser2 = p.iUser) === null || _p$iUser2 === void 0 ? void 0 : _p$iUser2.otherNames].filter(Boolean).join(" ");
};
var UserPicker = function UserPicker(props) {
  var onChange = props.onChange,
    modulesManager = props.modulesManager,
    _props$readOnly = props.readOnly,
    readOnly = _props$readOnly === void 0 ? false : _props$readOnly,
    _props$required = props.required,
    required = _props$required === void 0 ? false : _props$required,
    _props$withLabel = props.withLabel,
    withLabel = _props$withLabel === void 0 ? true : _props$withLabel,
    healthFacility = props.healthFacility,
    _props$filters = props.filters,
    filters = _props$filters === void 0 ? [] : _props$filters,
    value = props.value,
    label = props.label,
    filterOptions = props.filterOptions,
    filterSelectedOptions = props.filterSelectedOptions,
    placeholder = props.placeholder,
    _props$multiple = props.multiple,
    multiple = _props$multiple === void 0 ? false : _props$multiple;
  var minCharLookup = modulesManager.getConf("fe-admin", "usersMinCharLookup", 2);
  var dispatch = reactRedux.useDispatch();
  var _useState = React.useState(null),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    searchString = _useState2[0],
    setSearchString = _useState2[1];
  var _useTranslations = feCore.useTranslations("admin.UserPicker", modulesManager),
    formatMessage = _useTranslations.formatMessage;
  var _useState3 = React.useState(false),
    _useState4 = _slicedToArray__default["default"](_useState3, 2),
    open = _useState4[0],
    setOpen = _useState4[1];
  var users = reactRedux.useSelector(function (state) {
    return state.admin.users.items;
  });
  var isLoading = reactRedux.useSelector(function (state) {
    return state.admin.users.isLoading;
  });
  var _onInputChange = feCore.useDebounceCb(setSearchString, modulesManager.getConf("fe-admin", "debounceTime", 400));
  // eslint-disable-next-line no-shadow
  var handleChange = function handleChange(__, value) {
    onChange(value);
    if (!multiple) setOpen(false);
  };
  React.useEffect(function () {
    if ((searchString === null || searchString === void 0 ? void 0 : searchString.length) > minCharLookup) {
      dispatch(fetchUsers(modulesManager, [searchString && "str: \"".concat(searchString, "\"")].concat(_toConsumableArray__default["default"](filters !== null && filters !== void 0 ? filters : [])).filter(Boolean), !healthFacility));
    }
  }, [searchString]);
  React.useEffect(function () {
    if (open) {
      dispatch(fetchUsers(modulesManager, ["first: 10"].concat(_toConsumableArray__default["default"](filters !== null && filters !== void 0 ? filters : [])), !healthFacility));
    }
  }, [open]);
  return /*#__PURE__*/React__default["default"].createElement(lab.Autocomplete, {
    loadingText: formatMessage("loadingText"),
    openText: formatMessage("openText"),
    closeText: formatMessage("closeText"),
    clearText: formatMessage("clearText"),
    openOnFocus: true,
    multiple: multiple,
    disabled: readOnly,
    options: users,
    loading: isLoading,
    open: open,
    onOpen: function onOpen() {
      return setOpen(true);
    },
    onClose: function onClose() {
      return setOpen(false);
    },
    autoComplete: true,
    value: value,
    getOptionLabel: function getOptionLabel(option) {
      return formatSuggestion$1(option);
    },
    getOptionSelected: function getOptionSelected(option, v) {
      return option.id === v.id;
    },
    onChange: handleChange,
    filterOptions: filterOptions,
    filterSelectedOptions: filterSelectedOptions,
    onInputChange: function onInputChange(__, query) {
      return _onInputChange(query);
    },
    renderInput: function renderInput(inputProps) {
      return /*#__PURE__*/React__default["default"].createElement(core.TextField, _extends__default["default"]({}, inputProps, {
        variant: "standard",
        required: required,
        label: withLabel && (label || formatMessage("label")),
        placeholder: placeholder
      }));
    }
  });
};
var UserPicker$1 = feCore.withModulesManager(styles$9.withTheme(styles$9.withStyles(styles)(UserPicker)));

var formatSuggestion = function formatSuggestion(p) {
  if (!p) return "?";
  return [p.code, p.lastName, p.otherNames].filter(Boolean).join(" ");
};
var EnrolmentOfficerPicker = function EnrolmentOfficerPicker(props) {
  var onChange = props.onChange,
    modulesManager = props.modulesManager,
    _props$readOnly = props.readOnly,
    readOnly = _props$readOnly === void 0 ? false : _props$readOnly,
    _props$required = props.required,
    required = _props$required === void 0 ? false : _props$required,
    _props$withLabel = props.withLabel,
    withLabel = _props$withLabel === void 0 ? true : _props$withLabel,
    value = props.value,
    label = props.label,
    filterOptions = props.filterOptions,
    filterSelectedOptions = props.filterSelectedOptions,
    placeholder = props.placeholder,
    _props$multiple = props.multiple,
    multiple = _props$multiple === void 0 ? false : _props$multiple;
  var dispatch = reactRedux.useDispatch();
  var _useState = React.useState(null),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    searchString = _useState2[0],
    setSearchString = _useState2[1];
  var isLoading = reactRedux.useSelector(function (state) {
    return state.admin.enrolmentOfficers.isFetching;
  });
  var options = reactRedux.useSelector(function (state) {
    return state.admin.enrolmentOfficers.items;
  });
  React.useEffect(function () {
    dispatch(fetchEnrolmentOfficers(modulesManager, {
      first: searchString ? undefined : 10,
      searchString: searchString
    }));
  }, [searchString]);
  return /*#__PURE__*/React__default["default"].createElement(feCore.Autocomplete, {
    multiple: multiple,
    required: required,
    placeholder: placeholder,
    label: label,
    withLabel: withLabel,
    readOnly: readOnly,
    options: options,
    isLoading: isLoading,
    value: value,
    getOptionLabel: formatSuggestion,
    onChange: onChange,
    filterOptions: filterOptions,
    filterSelectedOptions: filterSelectedOptions,
    onInputChange: setSearchString
  });
};

var UserRolesPicker = function UserRolesPicker(_ref) {
  var _data$role$edges$map, _data$role;
  var readOnly = _ref.readOnly,
    value = _ref.value,
    _onChange = _ref.onChange,
    required = _ref.required,
    _ref$multiple = _ref.multiple,
    multiple = _ref$multiple === void 0 ? true : _ref$multiple,
    placeholder = _ref.placeholder,
    withLabel = _ref.withLabel,
    withPlaceholder = _ref.withPlaceholder,
    label = _ref.label,
    filterOptions = _ref.filterOptions,
    filterSelectedOptions = _ref.filterSelectedOptions;
  var _useState = React.useState(),
    _useState2 = _slicedToArray__default["default"](_useState, 2),
    searchString = _useState2[0],
    setSearchString = _useState2[1];
  var _useTranslations = feCore.useTranslations("admin"),
    formatMessage = _useTranslations.formatMessage;
  var _useGraphqlQuery = feCore.useGraphqlQuery("\n    query UserRolesPicker ($str: String) {\n      role(str: $str) {\n        edges {\n          node {\n            id name\n          }\n        }\n      }\n    }\n  ", {
      str: searchString
    }),
    isLoading = _useGraphqlQuery.isLoading,
    data = _useGraphqlQuery.data,
    error = _useGraphqlQuery.error;
  return /*#__PURE__*/React__default["default"].createElement(feCore.Autocomplete, {
    multiple: multiple,
    required: required,
    placeholder: placeholder !== null && placeholder !== void 0 ? placeholder : formatMessage("user.userRoles.placeholder"),
    label: label !== null && label !== void 0 ? label : formatMessage("user.userRoles"),
    error: error,
    withLabel: withLabel,
    withPlaceholder: withPlaceholder,
    readOnly: readOnly,
    options: (_data$role$edges$map = data === null || data === void 0 ? void 0 : (_data$role = data.role) === null || _data$role === void 0 ? void 0 : _data$role.edges.map(function (edge) {
      return edge.node;
    })) !== null && _data$role$edges$map !== void 0 ? _data$role$edges$map : [],
    isLoading: isLoading,
    value: value,
    getOptionLabel: function getOptionLabel(o) {
      return o === null || o === void 0 ? void 0 : o.name;
    },
    onChange: function onChange(option) {
      return _onChange(option, option === null || option === void 0 ? void 0 : option.name);
    },
    filterOptions: filterOptions,
    filterSelectedOptions: filterSelectedOptions,
    onInputChange: setSearchString
  });
};

var UserTypesPicker = function UserTypesPicker(props) {
  var intl = reactIntl.useIntl();
  var rights = reactRedux.useSelector(function (state) {
    return !!state.core && !!state.core.user && !!state.core.user.i_user ? state.core.user.i_user.rights : [];
  });
  var options = USER_TYPES(rights).map(function (ut) {
    return {
      id: ut,
      label: feCore.formatMessage(intl, "admin.user", "userTypes.".concat(ut))
    };
  });
  var value = [];
  if (props.value) {
    props.value.forEach(function (v) {
      var fullValue = options.find(function (o) {
        return o.id === v;
      });
      if (fullValue) {
        value.push(fullValue);
      }
    });
  }
  return /*#__PURE__*/React__default["default"].createElement(Autocomplete__default["default"], {
    multiple: true,
    noOptionsText: feCore.formatMessage(intl, "admin.user", "userTypes.noOptions"),
    disabled: props.readOnly,
    id: "user-types-select",
    options: options,
    getOptionLabel: function getOptionLabel(option) {
      return option.label;
    },
    onChange: function onChange(e, userTypes) {
      return props.onChange(userTypes.map(function (ut) {
        return ut.id;
      }));
    },
    renderInput: function renderInput(params) {
      return /*#__PURE__*/React__default["default"].createElement(TextField__default["default"], _extends__default["default"]({}, params, {
        variant: "standard",
        label: "".concat(feCore.formatMessage(intl, "admin.user", "userTypes")).concat(props.required ? "*" : ""),
        placeholder: ""
      }));
    },
    value: value
  });
};

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys$1(Object(source), !0).forEach(function (key) { _defineProperty__default["default"](target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    enrolmentOfficers: {
      items: [],
      isFetching: false,
      pageInfo: {
        totalCount: 0
      },
      error: null
    },
    usersSummaries: {
      items: [],
      isFetching: false,
      isFetched: false,
      fetched: null,
      pageInfo: {
        totalCount: 0
      },
      error: null
    },
    users: {
      items: [],
      isFetching: false,
      isFetched: false,
      error: null
    },
    fetchingUser: false,
    fetchedUser: false,
    errorUser: null,
    user: null,
    submittingMutation: false,
    mutation: {},
    reg_dst: [],
    obligatory_user_fields: {},
    obligatory_eo_fields: {}
  };
  var action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case "ADMIN_ENROLMENT_OFFICERS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        enrolmentOfficers: _objectSpread$1(_objectSpread$1({}, state.enrolmentOfficers), {}, {
          isFetching: true
        })
      });
    case "ADMIN_ENROLMENT_OFFICERS_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        enrolmentOfficers: _objectSpread$1(_objectSpread$1({}, state.enrolmentOfficers), {}, {
          isFetching: false,
          pageInfo: feCore.pageInfo(action.payload.data.enrolmentOfficers),
          items: feCore.parseData(action.payload.data.enrolmentOfficers)
        })
      });
    case "ADMIN_ENROLMENT_OFFICERS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        enrolmentOfficers: _objectSpread$1(_objectSpread$1({}, state.enrolmentOfficers), {}, {
          isFetching: false,
          error: feCore.formatGraphQLError(action.payload)
        })
      });
    case "ADMIN_USERS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        users: _objectSpread$1(_objectSpread$1({}, state.users), {}, {
          isFetching: true,
          fetched: null,
          error: null
        })
      });
    case "ADMIN_USERS_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        users: _objectSpread$1(_objectSpread$1({}, state.users), {}, {
          isFetching: false,
          fetched: action.meta,
          items: feCore.parseData(action.payload.data.users).map(function (user) {
            return _objectSpread$1(_objectSpread$1({}, user), {}, {
              userTypes: getUserTypes(user)
            });
          }),
          error: feCore.formatGraphQLError(action.payload)
        })
      });
    case "ADMIN_USERS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        users: _objectSpread$1(_objectSpread$1({}, state.users), {}, {
          error: feCore.formatServerError(action.payload),
          isFetching: false,
          items: []
        })
      });
    case "ADMIN_USERS_SUMMARIES_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        usersSummaries: _objectSpread$1(_objectSpread$1({}, state.usersSummaries), {}, {
          isFetching: true,
          isFetched: false,
          error: null
        })
      });
    case "ADMIN_USERS_SUMMARIES_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        usersSummaries: _objectSpread$1(_objectSpread$1({}, state.usersSummaries), {}, {
          isFetching: false,
          isFetched: true,
          fetched: action.meta,
          pageInfo: feCore.pageInfo(action.payload.data.users),
          items: feCore.parseData(action.payload.data.users),
          error: feCore.formatGraphQLError(action.payload)
        })
      });
    case "ADMIN_USERS_SUMMARIES_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        usersSummaries: _objectSpread$1(_objectSpread$1({}, state.usersSummaries), {}, {
          isFetching: false,
          isFetched: true,
          fetched: null,
          items: [],
          error: feCore.formatGraphQLError(action.payload)
        })
      });
    case "ADMIN_USER_OVERVIEW_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUser: true,
        fetchedUser: false,
        errorUser: null
      });
    case "ADMIN_USER_OVERVIEW_RESP":
      var users = feCore.parseData(action.payload.data.users);
      var user = null;
      if ((users === null || users === void 0 ? void 0 : users.length) > 0) {
        var _users = _slicedToArray__default["default"](users, 1);
        user = _users[0];
        user = mapQueriesUserToStore(user);
      }
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchingUser: false,
        fetchedUser: true,
        user: user,
        errorUser: feCore.formatGraphQLError(action.payload)
      });
    case "ADMIN_USER_OVERVIEW_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetchedUser: false,
        errorUser: feCore.formatServerError(action.payload)
      });
    case "ADMIN_USER_NEW":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        usersPageInfo: {
          totalCount: 0
        },
        user: null
      });
    case "LOCATION_REGION_DISTRICTS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_reg_dst: true,
        fetched_reg_dst: false,
        reg_dst: [],
        errorL1s: null
      });
    case "LOCATION_REGION_DISTRICTS_RESP":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_reg_dst: false,
        fetfetched_reg_dstchedL1s: true,
        reg_dst: feCore.parseData(action.payload.data.locations || action.payload.data.locationsStr),
        errorL1s: feCore.formatGraphQLError(action.payload)
      });
    case "LOCATION_REGION_DISTRICTS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_reg_dst: false,
        errorL1s: feCore.formatServerError(action.payload)
      });
    case "LOCATION_REGION_DISTRICTS_CLEAR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        reg_dst: []
      });
    case "OBLIGTORY_USER_FIELDS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_user_fields: true,
        fetched_obligatory_user_fields: false,
        obligatory_user_fields: null,
        errorL1s: null
      });
    case "OBLIGTORY_USER_FIELDS_RESP":
      console.log("USER FILED RESPONSE ", action.payload.data.userObligatoryFields);
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_user_fields: false,
        fetched_obligatory_user_fields: true,
        obligatory_user_fields: action.payload.data.userObligatoryFields,
        errorL1s: feCore.formatGraphQLError(action.payload)
      });
    case "OBLIGTORY_USER_FIELDS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_user_fields: false,
        errorL1s: feCore.formatServerError(action.payload)
      });
    case "OBLIGTORY_EO_FIELDS_REQ":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_eo_fields: true,
        fetched_obligatory_eo_fields: false,
        obligatory_eo_fields: null,
        errorL1s: null
      });
    case "OBLIGTORY_EO_FIELDS_RESP":
      console.log("EO FILED RESPONSE ", action.payload.data.eoObligatoryFields);
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_eo_fields: false,
        fetched_obligatory_eo_fields: true,
        obligatory_eo_fields: action.payload.data.eoObligatoryFields,
        errorL1s: feCore.formatGraphQLError(action.payload)
      });
    case "OBLIGTORY_EO_FIELDS_ERR":
      return _objectSpread$1(_objectSpread$1({}, state), {}, {
        fetching_obligatory_eo_fields: false,
        errorL1s: feCore.formatServerError(action.payload)
      });
    case "ADMIN_USER_MUTATION_REQ":
      return feCore.dispatchMutationReq(state, action);
    case "ADMIN_USER_MUTATION_ERR":
      return feCore.dispatchMutationErr(state, action);
    case "ADMIN_USER_UPDATE_RESP":
      return feCore.dispatchMutationResp(state, "updateUser", action);
    case "ADMIN_USER_DELETE_RESP":
      return feCore.dispatchMutationResp(state, "deleteUser", action);
    case "ADMIN_USER_CREATE_RESP":
      return feCore.dispatchMutationResp(state, "createUser", action);
    default:
      return state;
  }
}

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty__default["default"](target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var ROUTE_ADMIN_USERS = "admin/users";
var ROUTE_ADMIN_USER_OVERVIEW = "admin/users/overview";
var ROUTE_ADMIN_USER_NEW = "admin/users/new";
var DEFAULT_CONFIG = {
  translations: [{
    key: "en",
    messages: messagesEn
  }],
  reducers: [{
    key: "admin",
    reducer: reducer
  }],
  "core.Router": [{
    path: ROUTE_ADMIN_USERS,
    component: UsersPage$1
  }, {
    path: ROUTE_ADMIN_USER_NEW,
    component: UserPage$1
  }, {
    path: "".concat(ROUTE_ADMIN_USER_OVERVIEW, "/:user_id"),
    component: UserPage$1
  }],
  "core.MainMenu": [AdminMainMenu$1],
  refs: [{
    key: "admin.UserPicker",
    ref: UserPicker$1
  }, {
    key: "admin.EnrolmentOfficerPicker",
    ref: EnrolmentOfficerPicker
  }, {
    key: "admin.UserRolesPicker",
    ref: UserRolesPicker
  }, {
    key: "admin.UserTypesPicker",
    ref: UserTypesPicker
  }, {
    key: "admin.UserPicker.projection",
    ref: USER_PICKER_PROJECTION
  }, {
    key: "admin.users",
    ref: ROUTE_ADMIN_USERS
  }, {
    key: "admin.userOverview",
    ref: ROUTE_ADMIN_USER_OVERVIEW
  }, {
    key: "admin.userNew",
    ref: ROUTE_ADMIN_USER_NEW
  }],
  "invoice.SubjectAndThirdpartyPicker": [{
    type: "user",
    picker: UserPicker$1,
    pickerProjection: USER_PICKER_PROJECTION
  }]
};
var AdminModule = function AdminModule(cfg) {
  return _objectSpread(_objectSpread({}, DEFAULT_CONFIG), cfg);
};

exports.AdminModule = AdminModule;
//# sourceMappingURL=index.js.map
